﻿/*
 * C'Gol
 * Project based on Conway's Game of Life
 * 
 * Made by:
 * Alexander Noss
 * Christian Rautenberg
 * David Zentner
 * Philipp Erler
 * Stephan Schneider
 * 
 * As IT project for summer-semester 2011 (Group IT2D)
 * 
 * ####################################################################
 * CreateForm to set new FieldSize
 * Part of C'Gol GUI
 * ####################################################################
 * 
 * Last change:     2011 | 07 | 04
 * 
 * Mail me for feedback, version requests etc.: 	ph.erler@gmx.net
 * Look at http://www.hs-esslingen.de/~pherit00/website/index.htm
 * .Net - Framework 4.0 must be installed.
 * 
 */


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CGol
{
    public partial class frmCreate : Form
    {
        //delegate to function for file operation
        public delegate void setSize(int size);
        setSize setSizeDeleg;

        //constructors
        public frmCreate()
        {
            InitializeComponent();
        }

        //show oldsize in textbox
        public frmCreate(int oldSize)
        {
            InitializeComponent();
            textBox.Text = oldSize.ToString();
        }

        //set delegate
        public void setSizeFunction(setSize setSizeFunc)              //set delegate
        {
            setSizeDeleg = setSizeFunc;
        }

        //allow only numbers in textbox
        private void textBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            int isNumber = 0;
            e.Handled = !int.TryParse(e.KeyChar.ToString(), out isNumber);
        }

        //check input and create new field
        private void butAccept_Click(object sender, EventArgs e)
        {
            //try to get new field size
            int size = 0;
            try
            {
                size = System.Convert.ToInt32(textBox.Text);
            }
            catch (Exception)
            {
                System.Media.SystemSounds.Beep.Play();
                return;
            }

            //check if size is in valid area
            if (size > 100 || size < 1)
            {
                textBox.Text = (20).ToString();
                MessageBox.Show("Fieldsize is not valid. Try something between 1 and 100");
                return;
            }

            //create new field if delegate set
            if (setSizeDeleg != null)
                setSizeDeleg(size);
            else
                MessageBox.Show("No function set for creating a new field.");

            this.Dispose();
        }

        //close this window
        private void butCancel_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }
    }
}
