/*
 * C'Gol
 * Project based on Conway's Game of Life
 * 
 * Made by:
 * Alexander Noss
 * Christian Rautenberg
 * David Zentner
 * Philipp Erler
 * Stephan Schneider
 * 
 * As IT project for summer-semester 2011 (Group IT2D)
 * 
 * ####################################################################
 * DLL base functions
 * Part of C'Gol C-DLL
 * ####################################################################
 * 
 * Last change:     2011 | 07 | 04
 * 
 * Mail me for feedback, version requests etc.: 	ph.erler@gmx.net
 * Look at http://www.hs-esslingen.de/~pherit00/website/index.htm
 * .Net - Framework 4.0 must be installed.
 * 
 */


/*
Informatik Project SS2011
Semester:		IT2D
Author:			David Zentner
*/

#include "base.h"

// creates a two dimensional array with rnd values
void createArrayRandom();

//init dll
void initDll()
{
	initRand();
	ptrptrField = NULL;
	fieldSize = 0;
}

//set size of field
void setFieldSize(int size)
{
	fieldSize = size;
}

//get cell state at pos
int getCell(int x, int y)
{
	return ptrptrField[x][y];
}

void deleteField()
{
	if(ptrptrField != NULL)
	{
		//Not workin at the moment!

		//int x;
		//int y;

		/*
		for(y = 0; y < fieldSize; ++y)
		{
			//for(x = 0; x < fieldSize; ++x)
			//{
			//	free((int*) &ptrptrField[y][x]);
			//}
			free((int**) ptrptrField[y]);
		}*/

		/*
		for(y = 0; y < fieldSize; ++y)
		{
			free((int*) ptrptrField[y]);
		}*/

		free((int*) ptrptrField);

		initDll();
	}
}

void createArray(int newSize)
{
	int i;
	int j;
	newField(newSize);

	for(i = 0; i < fieldSize; ++i)
	{
		for(j = 0; j < fieldSize; ++j)
		{
			ptrptrField[j][i]=0;
		}
	}
}

void newField(int newSize)
{
	int i;

	deleteField();

	ptrptrField = (int **)calloc(newSize, sizeof(int *));

	for(i = 0; i < newSize; ++i)
	{
		ptrptrField[i] = (int *)calloc(newSize, sizeof(int));
	}
	setFieldSize(newSize);
}


/*
Informatik Project SS2011
Semester:		IT2D
Author:			Christian Rautenberg
Last Change:    05.06.2011
*/

// Christian: inizialization from Rand for a complete new random value
void initRand()
{
    srand((unsigned)time(NULL));
}

// Christian: return a random value between 0 and 1
int myRnd()
{
    return rand() % 2;
}

// Christian: function for field size
int getFieldSize()
{
    return fieldSize;
}

// Christian: function to fill the Array with Zeros
void createArrayZeros() // name change to Zero for 2 seperate functions zero and rnd
{
	int i;
	int j;
	newField(fieldSize);
	
    for (j = 0; j < fieldSize; j++)    // switch row to fieldSize
    {
		for (i = 0; i < fieldSize; i++)    // change column to fieldSize
        {
            ptrptrField[i][j] = 0;    // fill with zeros
        }   
    }  
}

// Christian: function to fill the Array with Random values between 1 or 0
void createArrayRandom() // 
{
	int i;
	int j;
	newField(fieldSize);

	
    for (j = 0; j < fieldSize; j++)    // switch row to fieldSize
    {
		for (i = 0; i < fieldSize; i++)    // change column to fieldSize
        {
            ptrptrField[i][j] = myRnd();    // fill with zeros
        }   
    }  
}

// fill existing field
void randomField() 
{
	int i;
	int j;
	   
	if (ptrptrField != NULL)
	{  
		for (j = 0; j < fieldSize; j++)    // switch row to fieldSize
		{
			for (i = 0; i < fieldSize; i++)    // change column to fieldSize
			{
				ptrptrField[i][j] = myRnd();    // fill with rnd
			}  
		}  
	}
	else
	{
		printf("ERROR: Array is empty");
	}
}

// Christian: change value from a position from 1to0 or 0to1
void switchCell (int x, int y)
{
    if ((x <= fieldSize && x >= 0) && (y <= fieldSize && y >= 0))
    {
        // changing Value on position x and y
        if (ptrptrField[y][x] == 1)   // changing value to 0
        {
            ptrptrField[y][x] = 0;
        }
        else if (ptrptrField[y][x] == 0)    // else changing value to 1
        {
            ptrptrField[y][x] = 1;
        }
        else    // if position not 1 or 0 then this is not allowed
        {
            printf("\nERROR no possible value\n");
            //return;
        }
    }
    else
    {
        printf("\nERROR no possible coordinate\n");
        //return;
    }
}